local playername = UnitName("player")
local lootitemstring = string.gsub(LOOT_ITEM, "%%s", "(.+)")
local lootitemmultiplestring = string.gsub(LOOT_ITEM_MULTIPLE, "%%s", "(.+)")
local lootitemselfstring = string.gsub(LOOT_ITEM_SELF, "%%s", "(.+)")
local lootitemselfmultiplestring = string.gsub(LOOT_ITEM_SELF_MULTIPLE, "%%s", "(.+)")

BadgeWatch = AceLibrary("AceAddon-2.0"):new("AceEvent-2.0")

local mod = BadgeWatch

local TokenList = {
	[29434] = true, -- Badge of Justice
	[40752] = true, -- Emblem of Heroism
	[40753] = true, -- Emblem of Valor
}

local LootList = {}
local IsTrackingItem = false

function mod:OnEnable()
	self:RegisterEvent("CHAT_MSG_LOOT")
end

function mod:CHAT_MSG_LOOT(msg)
	if not IsInInstance() then return end

	local looter, item
	looter, item = select(3, string.find(msg, lootitemstring))
	if not looter or not item then
		looter, item = select(3, string.find(msg, lootitemmultiplestring))
	end

	if not looter or not item then
		item = select(3, string.find(msg, lootitemselfstring))
		if item then
			looter = playername
		else
			item = select(3, string.find(msg, lootitemselfmultiplestring))
			if item then
				looter = playername
			end
		end
	end

	if type(item) ~= "string" or type(name) ~= "string" then return end
	local itemid = select(2, GetItemInfo(item)):match("item:(%d+)")
	if not TokenList[tonumber(itemid)] then return end

	-- First badge looted, fill the LootList
	if not IsTrackingItem then
		LootList[playername] = false
		for i = 1, GetNumRaidMembers() do
			local name, _, group = GetRaidRosterInfo(i)
			if name and (group < 6) then
				LootList[name] = false
			end
		end
		for i = 1, GetNumPartyMembers() do
			local name = UnitName("party"..i)
			if name then
				LootList[name] = false
			end
		end
		IsTrackingItem = tonumber(itemid)
	end

	self:ScheduleEvent("BadgeWatchCheck", self.CheckLoot, 2*60, self)
	self:ScheduleEvent("BadgeWatchReset", self.ResetTracking, 6*60, self)

	LootList[looter] = true
end

function mod:CheckLoot()
	local item = select(2, GetItemInfo(IsTrackingItem))
	for name, hasLooted in pairs(LootList) do
		if not hasLooted then
			SendChatMessage(("You forgot to loot your %s!"):format(item), "WHISPER", nil, name)
		end
	end
end

function mod:ResetTracking()
	LootList = {}
	IsTrackingItem = false
end
